/* $Id: Keyboard.java,v 1.1.1.1 2013/03/13 09:32:38 mit Exp $ */
/* Keyboard.java v0.4 for harmonics*/
import java.awt.*;

public class Keyboard {
    private final int Oct = 12;
    private final double Wl = 150; //Ĺ
    private final double Ww = 23;  // " 
    private final double Bl = 95;  // Ĺ
    private final double Bw = 11;  // " 
    private final double ar = Ww/8;   // 3
    private final double al = Ww/4;   // 6
    private final double cr = Ww/3;   // 8
    private final double bl = 3*Ww/8; // 9
    private final double dl = 3*Ww/16;// 4.5
    private final double Wdata[][] = { // left_side, right_side
	{al,ar},{bl,-1},{-1,cr},{dl,dl},{cr,-1},{-1,bl},{ar,al}};
    private final String Datarow = "ABCDEFG";     // wdata¥
    private final String Keyrow = "CbDbEFbGbAbB"; // ¥
    private final String[] Keynm = 
    {"C","Cis","D","Es","E","F","Fis","G","Gis","A","B","H"};
    private final Color ivory = new Color(255,255,244);

    private static double XW;  // Ǹkeyx
    private static double XB;  // μιΰ
    private static double value = 1.0; // 祵
    private static int Keynum; // keynm
    private static int xx;     // ϥޥx
    private static int yy;     // " y "
    private static int stkey;  // " keynm

    private boolean onoff; // keyon
    private char type;     // /
    private int number;    // 0 keyֹ
    private double kx;     // keyx
    private String name;   // key̾
    private Dpoint[] dp;   // keyΥݥꥴǡ
    private int[] xip;     // " x/åݥꥴǡ
    private int[] yip;     // " y "
    private Polygon pol;   // 嵭Υݥꥴ
    private int poln;      //  " 
    private Color col;     // /or¾

    public Keyboard() { /* x, y, Ψ, ǽΥ̾, , on/off */
	setKeyboard(0,0,0,' ',null,false);
    }
    public Keyboard(int x, int y, boolean sw) {
	setKeyboard(x,y,value,' ',null,sw);
    }
    /* () x, y, ǽΥ̾, on/off */
    public Keyboard(int x, int y, char ch, boolean sw) {
	setKeyboard(x,y,value,ch,null,sw);
    }
    public Keyboard(int x, int y, Color c, boolean sw) {
	setKeyboard(x,y,value,' ',c,sw);
    }
    public Keyboard(int x, int y, double v, char ch, boolean sw) {
	setKeyboard(x,y,v,ch,null,sw);
    }
    public Keyboard(int x, int y, double v, char ch, Color c, boolean sw) {
	setKeyboard(x,y,v,ch,c,sw);
    }
    public void setKeyboard(int x, int y, double v, char ch, Color c, boolean sw) {
	number = Keynum++;
	this.setStartKey(ch,c);
	xx = x;
	yy = y;
	onoff = sw;
	this.setValue(v); // ݥꥴ
    }
    public void setStartKey(char ch, Color c) { // for restart
	this.setStartkey(ch);
	this.setType(' ');
	this.setColor(c);
	this.setXWB();
	this.setName();
    }
    public void setStartkey(char ch) {
	stkey = (ch == ' ') ? 0 : Keyrow.indexOf(ch);
    }
    public void setType(char ch) {
	type = (ch != ' ') ? ch : Keyrow.charAt((stkey+number)%Oct);
    }
    public void setColor(Color c) {
	col = (c != null) ? c : (type == 'b') ? Color.black : ivory;
    }
    public void setXWB() {
	if (type == 'b')
	    kx = XB;
	else {
	    kx = XW;
	    XW += Ww+1; // keyδֳ(1)
	    XB = XW-Wdata[this.getDatanum(type)][1]; // keyδֳ(-1?)
	}
    }
    public void setName() {
	name = Keynm[(stkey+number)%Oct];
    }
    public void setValue(double v) {
	value = (v == 0) ? value : v;
	if (this.isType())
	    this.setPoly();
    }
    public void setX(int x) {
	xx = x;
	if (this.isType())
	    this.setPoly();
    }
    public void setPoly() {
	if (poln < 1)
            this.setPolygon(type);
	xip = new int[poln];
	yip = new int[poln];
	
	for (int i = 0; i < poln; i++) {
	    xip[i] = (int)((dp[i].x+kx)*value)+xx;
	    yip[i] = (int)(dp[i].y*value)+yy;
	}
	pol = new Polygon(xip, yip, poln);
    }
    public void setPolygon(char ch) {
	int max = 8;
	int cnt = 0;
	dp = new Dpoint[max];
	
	if (ch == 'b') { // 
	    dp[cnt++] = new Dpoint(0, Bl);
	    dp[cnt++] = new Dpoint(0, 0);
	    dp[cnt++] = new Dpoint(Bw, 0);
	    dp[cnt++] = new Dpoint(Bw, Bl); //4
	} else { // 
	    int num = this.getDatanum(ch); // key#(0~6)
	    dp[cnt++] = new Dpoint(0, Wl); //1 Ϥ
	    
	    if (Wdata[num][0] < 0 || number == 0) //¦/Ƭkey
		dp[cnt++] = new Dpoint(0, 0); //2
	    else {
		dp[cnt++] = new Dpoint(0, Bl);             //2
		dp[cnt++] = new Dpoint(Wdata[num][0], Bl); //3
		dp[cnt++] = new Dpoint(Wdata[num][0], 0);  //4
	    }
	    if (Wdata[num][1] < 0 || number == 87) //¦/Ǹkey
		dp[cnt++] = new Dpoint(Ww, 0); //3/5
	    else {
		dp[cnt++] = new Dpoint(Ww-Wdata[num][1], 0);  //3/5
		dp[cnt++] = new Dpoint(Ww-Wdata[num][1], Bl); //4/6
		dp[cnt++] = new Dpoint(Ww, Bl);               //5/7
	    }
	    dp[cnt++] = new Dpoint(Ww, Wl); //4/6/8
	}

	poln = cnt;
    }
    public boolean isType() {
	return (Keyrow.indexOf(type) >= 0) ? true : false;
    }
    public boolean isInside(int x, int y) {
	return pol.contains(x,y);
    }
    public void setSW(boolean sw) {
	onoff = sw;
    }
    public void setReStart() {
	XW = 0;
	XB = 0;
	kx = 0;
	value = 0;
	Keynum = 0;
    }
    public void setClear() {
	type = ' ';
	pol = null;
	dp = null;
	xip = null;
	yip = null;
    }
    public String getKeynm(int n) {
	return Keynm[(stkey+n)%Oct];
    }
    public int getKeynum() {
	return Keynum;
    }
    public int getDatanum(char key) {
	return Datarow.indexOf(key);
    }
    public double getX() {
	return kx*value+xx;
    }
    public int getNum() {
	return number;
    }
    public double getCenter() {
	return this.getX()+this.getMinwbx()/2;
    }
    public double getMinx() {
	return Ww*value;
    }
    public double getMinbx() {
	return Bw*value;
    }
    public double getMinwbx() {
	return (type == 'b') ? Bw*value : Ww*value;
    }
    public double getMaxX() {
	return XW;
    }
    public double getMaxx() {
	return XW*value;
    }
    public char getType() {
	return type;
    }
    public Polygon getPoly() {
	return pol;
    }
    public int[] getPolyx() {
	return xip;
    }
    public int[] getPolyy() {
	return yip;
    }
    public int getPoln() {
	return poln;
    }
    public double getValue() {
	return value;
    }
    public String getName() {
	return name;
    }
    public Color getColor() {
	return col;
    }
    public boolean getSW() {
	return onoff;
    }
    public String toString() {
	return name+","+number+","+(float)kx+","+type+","+onoff;
    }
    //---
    class Dpoint {
	double x, y;

	public Dpoint() {
	    x = 0;
	    y = 0;
	}
	public Dpoint(double a, double b) {
	    x = a;
	    y = b;
	}
    }
}
