/* $Id: harmonics.java,v 1.40 2017/02/20 08:13:33 mit3 Exp $ */
/* harmonics.java v0.5 */
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.text.DecimalFormat;

public class harmonics extends Applet
    implements ActionListener, ItemListener,
               MouseListener, MouseMotionListener
{
    private final int KB = 88;
    private final int OCTAVE = 12;
    private final int PMAX = 20;
    private final int PITCH = 440;
    private final int CENT12 = 1200;

    private final int PART = 0;
    private final int INTE = 1;
    private final int STRI = 2;
    private final int BEAT = 3;
    private final int INHA = 4;
    private final int CENT = 5;

    private final int SAMPLF = 44100;
    private final int SP88 = 22; // 1/22
    private final int SP49 = 8;  // 1/8
    private final int K49 = 49-1;
    private final int SA = KB-K49-1;
    private final double SAQ = Math.pow(SP88/(double)SP49, 1.0/SA);
    private final double CutoffL = 20.0;  // [Hz]
    private final double CutoffH = 170.0; //  "
    private final double Log10 = Math.log(10);
    private final double MC = CENT12/Math.log(2);
    private final int[] Multi = {
	0, 12, 19, 24, 28, 31, 34, 36, 38, 40,
	42, 43, 44, 46, 47, 48, 49, 50, 51, 52}; // max20
    private final double[] Offset = {
	0.0, 0.0, 1.955, 0.0, -13.6863, 1.955, -31.1741, 0.0,
	3.91, -13.6863, -48.6821, 1.955, 40.5277, -31.1741,
        -11.7313, 0.0, 4.9554, 3.91, -2.487, -13.6863}; // max20
    private final String[] KEY_NAME =
    {"A","B","H","C","Cis","D","Es","E","F","Fis","G","Gis"};
    private final String[] OCTAVE_NAME = 
    {"A2","A1","A","a","a1","a2","a3","a4"};
    private final String[] GRAPH =
    {"Partial", "Interval", "Strike", "Beat", "Inha.", "Cent"}; // 6
    private static final long serialVersionUID = 1L;

    private Choice chPartial;
    private Choice chInterval;
    private Button btText;
    private Button[] btGraph;
    private Button btPlus;
    private Button btMinus;
    private Button btOffset;
    private Button btTune;
    private Button btEqual;
    private Button btWide;
    private Button btNarrow;
    private Button btPkey;
    private Button btMkey;
    private TextField tfData;
    private TextArea taA;
    private CardLayout Card;
    private Panel Deck;
    private Canvas can;
    private Panel PN, PE, PW, PS;
    private Graphics gi;
    private Image ig;
    private Font Fnt;

    private boolean GT;
    private boolean TUNEsw = true;
    private boolean OFFSETsw;
    private boolean INHAsw = true;
    private int FNT;
    private int W, H, H2, HB, HK, HF;
    private int DOT, DSF;
    private int DOT2, DSF2;
    private int KEY, KEY2;
    private int mX, mY;
    private int PARTL;  // ܲ
    private int INTVL;  // 
    private int GRAP;
    private int CMAX;
    private int FMAX;
    private int FBY;
    private int Height;
    private double H0; // keyboard⤵
    private double BMAX;
    private double DK; // key
    private double DH; // cent
    private double DB; // beat
    private double DF; // freq.
    private int[] HARMO;
    private double[] Cent;
    private Color[] COL;
    private FontMetrics fm;
    private DecimalFormat df1 = new DecimalFormat("#0.0##");
    private DecimalFormat df2 = new DecimalFormat("00: ");

    private Keyboard[] K;
    private Interval IN;
    private MakeInharmonicity MI;
    private TuningTriads TT;

    public void init() {
        String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FNT);
        setFont(Fnt);
	fm = getFontMetrics(Fnt);
	Height = fm.getAscent();

	IN = new Interval();
	buildLayout();
        init_seting();
    }
    public void buildLayout() {
	setBackground(Color.lightGray);
        setLayout(new BorderLayout());

        PW = new Panel();
        PW.setLayout(new GridLayout(1,1,0,0));
        add(PW, "West");
	//---

        PE = new Panel();
        PE.setLayout(new GridLayout(1,1,0,0));
        add(PE, "East");
	//---

	PN = new Panel();
	PN.setLayout(new GridLayout(2,1,0,0));
        add(PN, "North");

	Panel n0 = new Panel();
	n0.setLayout(new FlowLayout());
	PN.add(n0);

	Panel n1 = new Panel();
	n1.setLayout(new FlowLayout());
	PN.add(n1);

        tfData = new TextField(34);
        tfData.setEditable(false);
        n0.add(tfData);

	chPartial = new Choice();
        for (int i = 0; i < PMAX; i++)
            chPartial.addItem(""+(i+1));
        n0.add(chPartial);
	chPartial.select(9); // PARTL:10
        chPartial.addItemListener(this);

        chInterval = new Choice();
        for (int i = 0; i < IN.getLen(); i++)
            chInterval.addItem(IN.toString(i));
        n0.add(chInterval);
        chInterval.select(IN.getIinte(OCTAVE));
        chInterval.addItemListener(this);
	//

	btMkey = new Button(" < ");
	btMkey.addActionListener(this);
	n1.add(btMkey);

	btPkey = new Button(" > ");
	btPkey.addActionListener(this);
	n1.add(btPkey);

	btWide = new Button(" < > ");
        btWide.addActionListener(this);
        n1.add(btWide);

	btNarrow = new Button(" > < ");
        btNarrow.addActionListener(this);
        n1.add(btNarrow);

	btTune = new Button("Tune3");
        btTune.addActionListener(this);
        n1.add(btTune);

	btEqual = new Button("Inhar.");
	btEqual.addActionListener(this);
	n1.add(btEqual);

        btOffset = new Button("(offset)");
        btOffset.addActionListener(this);
        n1.add(btOffset);

        btPlus = new Button(" + ");
        btPlus.addActionListener(this);
        n1.add(btPlus);

        btMinus = new Button(" - ");
        btMinus.addActionListener(this);
        n1.add(btMinus);
	//---

        PS = new Panel();
        PS.setLayout(new GridLayout(1,7,0,0));
        add(PS, "South");

	btGraph = new Button[GRAPH.length];
        for (int i = 0; i < GRAPH.length; i++) {
            btGraph[i] = new Button(GRAPH[i]);
            btGraph[i].addActionListener(this);
            PS.add(btGraph[i]);
        }

	btText = new Button("Graph.");
        btText.addActionListener(this);
        PS.add(btText);
	//---

        can = new MyCanvas();

        can.addMouseListener(this);
        can.addMouseMotionListener(this);

        Deck = new Panel();
        Card = new CardLayout();
        Deck.setLayout(Card);

	Panel card1 = new Panel();
        card1.add(can);
        Deck.add(card1, "card1");

        taA = new TextArea("", 16, 40, TextArea.SCROLLBARS_BOTH);
        taA.setFont(Fnt);
        taA.setEditable(false);

        ScrollPane card2 = new ScrollPane();
        card2.add(taA);
        Deck.add(card2, "card2");

	add(Deck, "Center");
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
	DK = W/(double)KB;
	CMAX = 80;
	BMAX = 32.0;
	FBY = 2;
	KEY = 25-1;
	KEY2 = KEY+INTVL;

        can.setSize(W, H);
        ig = createImage(W, H);
        gi = ig.getGraphics();
        gi.setFont(Fnt);

	set_keyboard_max();

	H0 = getKeyboardHeight();
	HK = (int)(H-H0);
	H2 = (int)(H0+HK/2);
	HB = HK/5;            // for log
	HF = H-FNT*2;
	DH = HK/(double)CMAX;
	DB = HK/BMAX;

	harmonicSelect();
	write_data();
    }
    /*
    public void destroy() {
        K[0].setReStart();
        for (int i = 0; i < KB; i++)
            K[i].setClear();
    }
    */
    public Dimension getCanvasD() {
        Dimension de = PE.getSize();
        Dimension dn = PN.getSize();
        Dimension ds = PS.getSize();
        Dimension dw = PW.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-8;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_seting() {
	K = new Keyboard[KB];
        MI = new MakeInharmonicity();
	TT = new TuningTriads();
	COL = new Color[PMAX];
	set_keyboard();

	initColor();
	initCent();
	getPartial();
	getInterval();  // INTVL:12 

	GRAP = PART;
	set_tune();
	set_enabled();
    }
    public void set_enabled() {
	boolean psw = (GRAP == PART);
	btOffset.setEnabled(psw);

	boolean ssw = (GRAP == STRI);
	btWide.setEnabled(ssw && !GT);
	btNarrow.setEnabled(ssw && !GT);

	boolean isw = (GRAP == INHA || ssw);
	btPlus.setEnabled(!isw && !GT);
	btMinus.setEnabled(!isw && !GT);

	btTune.setEnabled(INHAsw);
    }
    public void set_tune() {
        if (TUNEsw) {
	    TT.setInha(MI.getInha());
            TT.setCent(Cent);
	    TT.Tuning();
	    Cent = TT.getCent();
	} else {
	    initCent();
	    TT.setCent(Cent);
	}
    }
    public void set_tune_button() {
	TUNEsw = !TUNEsw;
	btTune.setLabel(TUNEsw ? "Clear" : "Tune3");

	set_tune();
    }
    public void set_keyboard() {
        for (int i = 0; i < KB; i++)
            K[i] = new Keyboard(1, 0, 'A', false);
        /* x, y, ϥ̾, on/off */
    }
    public void set_keyboard_max() {
        double val = W/K[0].getMaxX();
        for (int i = 0; i < KB; i++)
            K[i].setValue(val);
    }
    //
    public void disp_sw() {
        if (GT)
            re_write();
        else
            can.repaint();

	write_data();
    }
    public void mouseMoved(MouseEvent me) {}
    public void mouseDragged(MouseEvent me) {}
    public void mousePressed(MouseEvent m) {
        mX = m.getX();
	mY = m.getY();
	clearHarmo();
        keySelect();
	harmonicSelect();

        disp_sw();
    }
    public void keySelect() {
	for (int i = 0; i < KB; i++) {
            if (K[i].isInside(mX, mY)) {
                K[i].setSW(true);
                KEY = i;
		KEY2 = KEY+INTVL;
            }
	}
    }
    public void harmonicSelect() {
	HARMO = new int[PMAX];
	int tmp;

	for (int i = 0; i < PARTL; i++) {
	    tmp = KEY+Multi[i];
	    if (tmp < KB) {
		HARMO[i] = tmp;
		K[tmp].setSW(true);
	    } else
		break;
	}
    }
    public void clearHarmo() {
	for (int i = 0; i < KB; i++)
	    K[i].setSW(false);
    }
    public void mouseClicked(MouseEvent m) {}
    public void mouseReleased(MouseEvent m){}
    public void mouseEntered(MouseEvent m) {}
    public void mouseExited (MouseEvent m) {}
    public void actionPerformed(ActionEvent e) {
	for (int i = 0; i < GRAPH.length; i++) {
            if (e.getSource() == btGraph[i]) {
                set_graph(i);
                break;
            }
        }
	if (e.getSource() == btText)
            disp_text();

	else if (e.getSource() == btPlus)
	    set_value(true);
	else if (e.getSource() == btMinus)
	    set_value(false);

	else if (e.getSource() == btOffset)
	    set_offset();

	else if (e.getSource() == btTune)
	    set_tune_button();

	else if (e.getSource() == btEqual)
	    set_equal();

	else if (e.getSource() == btWide)
	    set_wide(true);
	else if (e.getSource() == btNarrow)
	    set_wide(false);

	else if (e.getSource() == btPkey)
	    set_key(true);
	else if (e.getSource() == btMkey)
	    set_key(false);

	set_enabled();
	disp_sw();
    }
    public void set_key(boolean sw) {
	clearHarmo();

	KEY = sw ? KEY+1 : KEY-1;
	if (KEY < 0)
	    KEY = 0;
	if (KEY >= KB)
	    KEY = KB-1;

	KEY2 = KEY+INTVL;
	K[KEY].setSW(true);
	harmonicSelect();
    }
    public void set_equal() {
	INHAsw = !INHAsw;

	if (!INHAsw)
	    initCent();
	else
	    set_tune();

	btEqual.setLabel(INHAsw ? "Inhar." : "Equal");
    }
    public void set_wide(boolean sw) {
	int min = 2, max = 256;
	FBY = sw ? FBY/2 : FBY*2;
	if (FBY < min)
	    FBY = min;
	else if (FBY > max)
	    FBY = max;
    }
    public void set_offset() {
	OFFSETsw = !OFFSETsw;

	btOffset.setLabel(OFFSETsw ? "Offset" : "(offset)");
    }
    public void set_value(boolean sw) {
	switch(GRAP) {
	case INHA:
	    break;
	case CENT:
	    CMAX = sw ? CMAX*2 : CMAX/2;
	    if (CMAX < 10)
		CMAX = 10;
	    break;
	case PART:
	case INTE:
	case BEAT:
	    BMAX = sw ? BMAX*2 : BMAX/2;
	    break;
	default:
	}
    }
    public void set_graph(int sw) {
	GRAP = sw;
    }
    public void disp_text() {
       GT = !GT;

       btText.setLabel(GT ? "Text " : "Graph.");
       Card.next(Deck);
    }
    public void itemStateChanged(ItemEvent e) {
	if (e.getSource() == chPartial) {
	    getPartial();
	    clearHarmo();
	    harmonicSelect();
	}
	if (e.getSource() == chInterval)
	    getInterval();

	disp_sw();
    }
    public void getPartial() {
	PARTL = Integer.parseInt(chPartial.getSelectedItem());
    }
    public void getInterval() {
	INTVL = IN.getIvalue(chInterval.getSelectedIndex());
	KEY2 = KEY+INTVL;
    }
    public int[] getInteData() {
	return IN.getIdata(chInterval.getSelectedIndex());
    }
    //
    public void write_data() {
	StringBuffer sb = new StringBuffer(40);
	sb.append(getKeyName(KEY)+": ");
	if (INHAsw)
	    sb.append(dform(TT.get_ifreq(KEY, 1))+"[Hz]");
	else
	    sb.append(dform(getFreq(KEY))+"[Hz] ");

	switch(GRAP) {
	case INHA:
	    sb.append(" "+dform(MI.getInha(KEY)));
	    break;
	case CENT:
	    sb.append(" "+dform(Cent[KEY]));
	    break;
	case PART:
	case INTE:
	case STRI:
	case BEAT:
	default:
	}

	tfData.setText(sb.toString());
    }
    public String getKeyName(int key) {
        return (key+1)+"("+KEY_NAME[key%12]+")";
    }
    //
    public void re_write() {
	switch(GRAP) {
	case INHA:
	    inha_write();
	    break;
	case CENT:
	    cent_write();
	    break;
	case PART:
	    part_write();
	    break;
	case INTE:
	    inte_write();
	    break;
	case BEAT:
	    beat_write();
	    break;
	case STRI:
	    sp_write();
	    break;
	default:
	}
    }
    public void inha_write() {
	StringBuffer str = new StringBuffer(1024);
	str.append(" Key# [Hz] inharmonicity \n");
	str.append("------------------------- \n");
	for (int i = 0; i < KB; i++) {
	    str.append(getKeyName(i));
	    str.append(format2(TT.get_ifreq(KEY, 1), MI.getInha(i)));
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public void cent_write() {
	StringBuffer str = new StringBuffer(1024);
	str.append("Key#  [Hz]  [cent] \n");
	str.append("------------------- \n");
	for (int i = 0; i < KB; i++) {
	    str.append(getKeyName(i));
	    str.append(format2(TT.get_ifreq(i, 1), Cent[i]));
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public void beat_write() {
	StringBuffer str = new StringBuffer(1024);
	str.append(getKeyName(KEY));
	if (KEY2 < KB)
	    str.append(": "+getKeyName(KEY2));
	str.append("\n");
	str.append("----------------------- \n");
	int itv[] = getInteData();

	for (int i = 1; i <= PARTL; i++) {
	    if (itv[0]*i > PARTL || KEY2 >= KB)
                break;

	    str.append(itv[0]*i+":");
	    str.append(itv[1]*i+" ");
	    if (INHAsw)
	    	str.append(dform(get_inha_beat(i, KEY, itv)));
	    else
	    	str.append(dform(get_equal_beat(i, KEY, itv)));

	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public void sp_write() {
	StringBuffer str = new StringBuffer(1024);
	str.append(" #: "+getKeyName(KEY)+"[Hz] volume ");
	if (KEY2 < KB)
	    str.append(getKeyName(KEY2)+"[Hz] volume");
	str.append("\n");
	str.append("----------------------------------------\n");
	double f0;
	double fr1 = getFreq(KEY);
	double fr2 = 0;
	if (KEY2 < KB)
	    fr2 = getFreq(KEY2);

	for (int i = 1; i <= PARTL; i++) {
	    str.append(dform2(i));
	    f0 = INHAsw ? TT.get_ifreq(KEY, i) : fr1*i;
	    str.append(format2(f0, calc_sindo(f0, i)));
	    if (KEY2 < KB) {
		f0 = INHAsw ? TT.get_ifreq(KEY2, i) : fr2*i;
		str.append(format2(f0, calc_sindo(f0, i)));
	    }
	    str.append("\n");
	}

 	taA.setText(str.toString());
    }
    public void inte_write() {
	StringBuffer str = new StringBuffer(1024);
	int lp, hp, itv[] = getInteData();

	str.append(" #: "+getKeyName(KEY)+" [Hz]");
	if (KEY2 < KB) {
	    str.append(": "+getKeyName(KEY2)+" [Hz]");
	    str.append("/ "+itv[0]+" : "+itv[1]+" diff");
	}
	str.append("\n");
	str.append("------------------------------- \n");

	double lf, hf;
	double[] f1 = calcPartial(PARTL, KEY);
	double[] f2 = new double[PARTL];
	if (KEY2 < KB)
	    f2 = calcPartial(PARTL, KEY2);

	for(int i = 1; i <= PARTL; i++) {
	    str.append(dform2(i));
	    lf = INHAsw ? f1[i-1] : getFreq(KEY)*i;
	    str.append(dform(lf)+" ");

	    if (KEY2 < KB) {
		hf = INHAsw ? f2[i-1] : getFreq(KEY2)*i;
		str.append(dform(hf));

		lp = itv[0]*i;
		hp = itv[1]*i;
		if (lp <= PARTL) {
		    str.append("/ "+lp+":"+hp);
		    if (INHAsw) {
		    	str.append(format3(f1[lp-1], f2[hp-1], f2[hp-1]-f1[lp-1]));
		    } else {
			lf = getFreq(KEY)*lp;
			hf = getFreq(KEY2)*hp;
			str.append(format3(lf, hf, hf-lf));
		    }
		}
	    }
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public double[] calcPartial(int mul, int key) {
	double[] f = new double[mul];
	for (int i = 0; i < mul; i++)
	    f[i] = TT.get_ifreq(key, i+1);
	return f;
    }
    public void part_write() {
	StringBuffer str = new StringBuffer(1024);
	str.append(" #: Key: Partial[Hz] Key[Hz] Diff [cent]\n");
	str.append("--------------------------------------- \n");
	int key, ii;
	double fnd, frq, kfr, df, ifr, ikf, idf;
	double[] mul = calcPartial(PARTL, KEY);
	fnd = getFreq(KEY);

	for(int i = 0; i < PARTL; i++) {
	    key = KEY+Multi[i];
	    if (key < KB) {
		ii = i+1;
		str.append(formatKey(ii, key));
		
		if (INHAsw) {
		    ifr = mul[i];
		    str.append(dform(ifr));
		    ikf = OFFSETsw ? ctof(TT.get_ifreq(key, 1), Offset[i]) :
			TT.get_ifreq(key, 1);
		    idf = ifr-ikf;
		    str.append(format3(ikf, idf, ftoc(key, ifr)));
		} else {
		    frq = fnd*ii;
		    str.append(dform(frq));
		    kfr = OFFSETsw ? ctof(getFreq(key), Offset[i]) :
			getFreq(key);
		    df = frq-kfr;
		    str.append(format3(kfr, df, ftoc(key, frq)));
		}
		str.append("\n");
	    }
	}

	taA.setText(str.toString());
    }
    public String formatKey(int n, int key) {
	StringBuffer str = new StringBuffer();

	str.append(dform2(n));
	str.append(getKeyName(key)+": ");

	return str.toString();
    }
    public String format2(double a, double b) {
   	StringBuffer str = new StringBuffer();

	str.append(" "+dform(a));
	str.append(" "+dform(b));

	return str.toString();
    }
    public String format3(double a, double b, double c) {
   	StringBuffer str = new StringBuffer();

	str.append(" "+dform(a));
	str.append(" "+dform(b));
	str.append(" "+dform(c));

	return str.toString();
    }
    public double[] getFreqs(int key, int par) {
	double[] f = new double[par];
	for (int i = 0; i < par; i++) {
	    f[i] = getFreq(key)*(i+1);
	}

	return f;
    }
    public double getFreq(int key) {
	return PITCH*Math.pow(2, (key-48)/(double)OCTAVE);
    }
    public double ftoc(int key, double f) {
        return MC*Math.log(f/getFreq(key));
    }
    public String dform(double n) {
        return df1.format((float)n);
    }
    public String dform2(int n) {
        return df2.format(n);
    }
    public void initCent() {
	Cent = new double[KB];
	for (int i = 0; i < KB; i++)
	    Cent[i] = 0;
    } 
    //
    class MyCanvas extends Canvas {
        private static final long serialVersionUID = 1L;

        public void update (Graphics g) {
            can.paint(g);
        }
        public void paint(Graphics g) {
            paintI();
            g.drawImage(ig, 0, 0, this);
        }
    }
    public void paintI() {
        backBlack(gi);
	initDot();
	dispKeyboard(gi);

	DH = HK/(double)CMAX;
	DB = HK/BMAX;
	FMAX = SAMPLF/FBY;
	DF = W/(double)FMAX;

	switch(GRAP) {
	case INHA:
	    dispInha(gi);
	    break;
	case CENT:
	    dispCent(gi);
	    break;
	case PART:
	    dispPartial(gi);
	    break;
	case INTE:
	    dispInterval(gi);
	    break;
	case BEAT:
	    dispBeat(gi);
	    break;
	case STRI:
	    dispStrike(gi);
	    break;
	default:
	}
    }
    public void backBlack(Graphics g) {
        g.setColor(Color.black);
        g.fillRect(0, 0, W, H);
    }
    public void initDot() {
        DOT = (int)DK;
        DSF = (int)(DK/2);

	DOT2 = (int)(W/(PMAX*3.0));
	DSF2 = DOT2/2;
    }
    public double getKeyboardHeight() {
	return 150*K[0].getValue();
    }
    public void initColor() {
        double dc = 1.0/PMAX;
        float c0, sft = 0.0f;
        for (int i = 0; i < PMAX; i++) {
            c0 = (float)(dc*i+sft);
            if (c0 > 1.0)
                c0 -= 1.0;
            COL[i] = Color.getHSBColor(c0, 1.0f, 1.0f);
        }
    }
    //
    public void dispKeyboard(Graphics g) {
	Polygon p;

	for (int i = 0; i < KB; i++) {
	    p = K[i].getPoly();

            set_key_color(g, i);
            g.fillPolygon(p);

            g.setColor(Color.gray);
            g.drawPolygon(p);
        }
    }
    public void set_key_color(Graphics g, int key) {
        if (key == KEY)
            g.setColor(Color.pink);
	else if (key == KEY2)
	    g.setColor(Color.cyan);
	else if (K[key].getSW())
	    g.setColor(Color.orange);
	else
            g.setColor(K[key].getColor());
    }
    //
    public void dispInha(Graphics g) {
	disp_log(g);
	disp_aline(g);

        for (int i = 0; i < KB; i++) {
	    set_mouse_color(g, i);
            g.fillOval((int)(i*DK), (int)log_h(MI.getInha(i)), DOT, DOT);
        }
    }
    public void set_mouse_color(Graphics g, int key) {
	if (key == KEY)
	    g.setColor(Color.magenta);
	else if (key == KEY2)
	    g.setColor(Color.green);
	else
	    g.setColor(Color.white);
    }
    public double log_h(double val) {
	return H2-log_base(val)*HB-DSF;
    }
    public double calc_h(double ih) {
        return H2-log_base(ih)*HB;
    }
    public double log_base(double value) {
      return Math.log(value)/Log10;
    }
    public void disp_log(Graphics g) {
        double h0 = 0.001, hl;
        int hm;

        for (int i = 1; i < 6; i++) { // ʿ
            hl = h0*Math.pow(10, i);
            hm = (int)calc_h(hl);

            g.setColor(Color.blue);
            g.drawLine(0, hm, W, hm);

            g.setColor(Color.orange); // 
            g.drawString(""+(float)hl, 2, hm);
        }
    }
    public void disp_aline(Graphics g) {
        int wi;

        for (int i = 0; i < OCTAVE_NAME.length; i++) {
            wi = (int)(DK*i*OCTAVE+DSF);

            g.setColor(Color.blue);
            g.drawLine(wi, (int)H0, wi, H);

            g.setColor(Color.red);
            g.drawString(OCTAVE_NAME[i], wi, H-FNT);
        }
    }
    //
    public void dispCent(Graphics g) {
	disp_cent_line(g);
	disp_center_line(g);
	disp_aline(g);

	double val;
	for (int i = 0; i < KB; i++) {
	    val = get_h(INHAsw ? TT.getCent(i) : Cent[i]);
	    if (val > H || val < H0)
		continue;
	    set_mouse_color(g, i);
	    g.fillOval((int)(DK*i), (int)val, DOT, DOT);
        }
    }
    public double get_h(double val) {
	return H2-val*DH-DSF;
    }
    public void disp_cent_line(Graphics g) {
        int py, my = 0;
        double yy, hi;
        double dy = CMAX/8.0;

        for (int i = 1; i < 5; i++) {
            hi = dy*i;
            yy = hi*DH;
            py = (int)(H2-yy);
	    my = (int)(H2+yy);

            g.setColor(Color.blue);
            g.drawLine(0, py, W, py);
            g.drawLine(0, my, W, my);

            g.setColor(Color.lightGray);
            g.drawString(dform(hi), 2, py+Height);
            g.drawString(dform(-hi), 2, my);
        }
    }
    //
    public void dispPartial(Graphics g) {
	double dx = W/(double)PARTL;
	double[] mul = calcPartial(PARTL, KEY);
	int k, x, y, sft = (int)(dx/4.0);

	disp_partl_line(g, dx, sft);
	disp_beat_line(g);
	disp_center_line(g);

	for (int i = 0; i < PARTL; i++) {
	    k = KEY+Multi[i];
	    if (k >= KB)
		break;

	    x = (int)(dx*i+sft);
	    y = (int)calc_b(INHAsw ? calc_ibeat(k, mul[i], i) :
	    		    calc_beat(i+1, k));
	    if (y > H || y < H0)
		continue;

	    g.setColor(INHAsw ? Color.white : Color.red);
	    g.fillOval(x, y, DOT2, DOT2);
	    /*
	    y = (int)calc_b(calc_beat(i+1, k));
	    g.setColor(Color.red);
	    g.fillOval(x, y, DOT2, DOT2);

	    y = (int)calc_b(calc_ibeat(k, mul[i], i));
	    g.setColor(Color.white);
	    g.drawOval(x, y, DOT2, DOT2);
	    *///for debug
	}
    }
    public double calc_b(double val) {
	int dsf = (GRAP == BEAT) ? DSF : DSF2;
	return H2-val*DB-dsf;
    }
    public void disp_center_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);
    }
    public double calc_beat(int par, int key) {
	double kf = OFFSETsw ? 
	    ctof(getFreq(key), Offset[par-1]) : getFreq(key);

       	return getFreq(KEY)*par-kf;
    }
    public double ctof(double f, double c) {
        return f*Math.pow(2, c/CENT12);
    }
    public double calc_ibeat(int key, double mu, int par) {
	double fr = OFFSETsw ? 
	    ctof(TT.get_ifreq(key, 1), Offset[par]) : TT.get_ifreq(key, 1); 

	return mu-fr;
    }
    public void disp_partl_line(Graphics g, double dx, int sft) {
	int x;

	for (int i = 0; i < PARTL; i++) {
	    x = (int)(dx*i+DSF2+sft);

	    g.setColor(Color.blue);
            g.drawLine(x, (int)H0, x, H);

            g.setColor(Color.yellow);
	    g.drawString((i+1)+"", x, H-FNT);
	}
    }
    public void disp_beat_line(Graphics g) {
	int my, py;
	double hi, yy;
        double dy = BMAX/8.0;

	for (int i = 1; i < 5; i++) {
            hi = dy*i;
            yy = hi*DB;
            py = (int)(H2-yy);
	    my = (int)(H2+yy);

	    g.setColor(Color.blue);
	    g.drawLine(0, py, W, py);
	    g.drawLine(0, my, W, my);

            g.setColor(Color.pink);
            g.drawString(dform(hi), 2, py+Height);
            g.drawString(dform(-hi), 2, my);
        }
    }
    //
    public void dispInterval(Graphics g) {
	int itv[] = getInteData();
	double dx = W/(double)PMAX;
	int x, y, lp, hp, sft = (int)(dx/4);

	disp_intvl_line(g, dx, sft);
	disp_beat_line(g);
	disp_center_line(g);

	if (KEY2 >= KB)
	  return;
	for (int i = 1; i <= PARTL; i++) {
	    x = (int)(dx*(i-1)+sft);

	    if (itv[0]*i <= PARTL) { // 2:1ʤ礭ܿ
		y = (int)calc_b(INHAsw ? get_inha_beat(i, KEY, itv) :
			get_equal_beat(i, KEY, itv));
		if (y > H || y < H0)
		    continue;

		g.setColor(INHAsw ? Color.white : Color.red);
		g.fillOval(x, y, DOT2, DOT2);
		/*
		y = (int)calc_b(get_equal_beat(i, KEY, itv));
		g.setColor(Color.red);
		g.fillOval(x, y, DOT2, DOT2);

		y = (int)calc_b(get_inha_beat(i, KEY, itv));
		g.setColor(Color.white);
		g.drawOval(x, y, DOT2, DOT2);
		*/// for debug
	    }
	}
    }
    public void disp_intvl_line(Graphics g, double dx, int sft) {
	int x;

	for (int i = 1; i <= PMAX; i++) {
	    x = (int)(dx*(i-1)+DSF2+sft);

	    g.setColor(Color.blue);
            g.drawLine(x, (int)H0, x, H);

            g.setColor(Color.yellow);
	    g.drawString(i+"", x, H-FNT);
	}
    }
    //
    public void dispStrike(Graphics g) {
	disp_scale(g);

	int x, ii;
	double gain = HK*0.8;
	double val, fr2[] = new double[PARTL];
	double[] fr1 = INHAsw ? calcPartial(PARTL, KEY) :
	    getFreqs(KEY, PARTL);

	if (KEY2 < KB)
	    fr2 = INHAsw ? calcPartial(PARTL, KEY2) :
	    	getFreqs(KEY2, PARTL);

	for (int i = 1; i <= PARTL; i++) {
	    ii = i-1;
	    x = (int)(fr1[ii]*DF);
	    val = gain*calc_sindo(fr1[ii], i);
	    set_strike_color(g, KEY, val);
	    g.drawLine(x, HF, x, (int)(HF-val)); 

	    if (KEY2 < KB) {
		x = (int)(fr2[ii]*DF);
		val = gain*calc_sindo(fr2[ii], i);
		set_strike_color(g, KEY2, val);
		g.drawLine(x, HF, x, (int)(HF-val));
	    } 
	}
    }
    public void set_strike_color(Graphics g, int key, double val) {
	if (key == KEY)
	    g.setColor(Color.pink);
	else if (key == KEY2)
	    g.setColor(Color.cyan);
    }
    public void disp_scale(Graphics g) {
        int spi, l;

        for (int i = 0; i < FMAX; i += 10) {
	    if (i % 10000 == 0) {
                if (FMAX >= 10000)
                    disp_k_memori(g, i);
                l = 20;
            } else if (i%5000 == 0) {
                if (FMAX >= 5000)
                    disp_k_memori(g, i);
                l = 17;
            } else if (i%1000 == 0) {
                if (FMAX < 12000)
                    disp_k_memori(g, i);
                l = 15;
            } else if (i%500 == 0) {
                if (FMAX > 23000)
                    continue;
                l = 11;
            } else if (i%100 == 0) {
                if (FMAX > 12000)
                    continue;
                l = 8;
            } else if (i%10 == 0) {
		if (FMAX > 2000)
                    continue;
                l = 5;
            } else
                continue;

            spi = (int)(DF*i);
	    g.setColor(Color.gray);
            g.drawLine(spi, HF, spi, HF+l);
	}

	g.drawLine(0, HF, W, HF);
    }
    public void disp_k_memori(Graphics g, int k) {
        g.setColor(Color.orange);
        g.drawString(k/1000+"k", (int)(DF*k), H);
    }
    public double calc_sindo(double freq, int pr) {
        double fg = get_sboard(freq);
        double sp = get_spoint();
        double ga = spoint(pr, sp);

        return ga*fg;
    }
    public double get_spoint() { // 0~481/8
        return (KEY <= K49) ? (double)SP49 : SP49*Math.pow(SAQ, KEY-K49);
    }
    public double spoint(int mm, double sp) {
        double mp = mm * Math.PI;
        return Math.abs(8.0*Math.sin(mp/sp)/mp); // ̵· 8
    }
    public double get_sboard(double freq) {
	freq -= CutoffL;
        double gain = freq/CutoffH;

        if (gain < 0)
            gain = 0.0;
        else if (gain > 1.0)
            gain = 1.0;

	return gain;
    }
    //
    public void dispBeat(Graphics g) {
	disp_beat_line(g);
	disp_center_line(g);
	disp_aline(g);

	int itv[] = getInteData();
	int kmax = KB-itv[2];
	int len;
	String str;
	double val;
	Color co;

	for (int j = 1; j <= PARTL; j++) {
	    if (itv[0]*j > PARTL || KEY2 >= KB)
                break;

	    co = COL[j-1];
	    g.setColor(co);
	    str = itv[0]*j+":"+itv[1]*j;
	    len = fm.stringWidth(str);
	    g.drawString(str, W-len, (int)(H0+FNT*j));

	    for (int i = 0; i < kmax; i++) {
		val = INHAsw ? calc_b(get_inha_beat(j, i, itv)) :
		    calc_b(get_equal_beat(j, i, itv));
		if (val > H || val < H0)
		    continue;

		set_beat_color(g, i, co);
		g.fillOval((int)(DK*i), (int)val, DOT, DOT);
	    }
	}
    }
    public double get_equal_beat(int par, int key, int itv[]) {
	int k2 = key+itv[2];
	double fl = getFreq(key)*itv[0]*par;
	double fh = getFreq(k2)*itv[1]*par;

	return fh-fl;
    }
    public void set_beat_color(Graphics g, int key, Color co) {
	if (key == KEY)
	    g.setColor(Color.white);
	else if (key == KEY2)
	    g.setColor(Color.lightGray);
	else
	    g.setColor(co);
    }
    public double get_inha_beat(int par, int key, int[] itv) {
	int k2 = key+itv[2];
	double fl = TT.get_ifreq(key, itv[0]*par);
	double fh = TT.get_ifreq(k2, itv[1]*par);

	return fh-fl;
    }
}
